/** 
 * Program:     Add2SecondGap.js
 * Description: This script will add a 2 second gap required for CD audio tracks.
 *              Note: You should have ripple edit OFF before using this script.
 *
 * Author: Johnny (Roy) Rofrano  john_rofrano@hotmail.com
 * 
 * Date: March 24, 2004
 *
 **/ 

import Sony.Vegas; 
import System.Windows.Forms;

var twoSecondGap : Timecode = new Timecode("00:00:02.00");

try
{
	// step through all selected video events:
	for (var track in Vegas.Project.Tracks) 
	{
		if( !track.Selected) continue;
		var tracktime = twoSecondGap;
		for (var evnt in track.Events) 
		{
			evnt.AdjustStartLength(tracktime, evnt.Length, true);
			tracktime = tracktime + evnt.Length + twoSecondGap;
		}
	}
}
catch (errorMsg)
{
	MessageBox.Show(errorMsg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
}
