'****************************************
'Script created by Lars Netzel 2003-08-05
'****************************************
'This script will splitt selected events with the frame
'intervall you decide. Then mute every other frame to
'create a blinking effect. 
'****************************************

Imports Sony.Vegas
Imports System.Windows.Forms.Form
Imports System.Windows.Forms
Imports System.Collections
Imports System
Imports System.Drawing
Imports System.ComponentModel
Imports System.IO

Public Module MainModule

    Public Sub Main()

        SplittEvents(GetInputValue())
    End Sub

    Public Function GetInputValue() As Long
        'prompt User For Input  
        Dim InputValue As String
        InputValue = InputBox("Type the number of frames you want to mute in the blinking (higher number will create slower effect)")
        Try
            GetInputValue = CLng(InputValue)
        Catch objE As Exception
            MessageBox.Show("Input was not a valid number", "Oops!")
            GetInputValue = 0
        End Try
    End Function

    Public Sub SplittEvents(ByVal NumberOfFrames As Long)
        Dim EndFrame As Long
        Dim FrameCounter As Long
        Dim anEnum As IEnumerator
        Dim SelectedTracks As Integer
        Dim SplitTimeCode As New Sony.MediaSoftware.Vegas.Timecode()
        anEnum = VegasApp.Project.Tracks.GetEnumerator
        While anEnum.MoveNext 'Loop through the tracks
            If CType(anEnum.Current(), Sony.MediaSoftware.Vegas.Track).IsVideo Then
                Dim EventEnum As IEnumerator
                EventEnum = CType(anEnum.Current(), Sony.MediaSoftware.Vegas.Track).Events.GetEnumerator
                While EventEnum.MoveNext 'Loop through Events
                    Dim TrackEvent As Sony.MediaSoftware.Vegas.TrackEvent
                    TrackEvent = CType(EventEnum.Current, Sony.MediaSoftware.Vegas.TrackEvent)
                    If TrackEvent.Selected = True Then
                        EndFrame = (GetStartFrame(TrackEvent) + GetLength(TrackEvent))
                        SplitTimeCode.FrameCount = NumberOfFrames
                        TrackEvent.Split(SplitTimeCode)
                    End If
                End While
            End If
        End While
        DeleteEveryOtherEvent()
    End Sub

    Public Sub DeleteEveryOtherEvent()
        Dim EndFrame As Long
        Dim FrameCounter As Long
        Dim anEnum As IEnumerator
        Dim SelectedTracks As Integer
        anEnum = VegasApp.Project.Tracks.GetEnumerator
        While anEnum.MoveNext 'Loop through the tracks
            If CType(anEnum.Current(), Sony.MediaSoftware.Vegas.Track).IsVideo Then
                Dim EventEnum As IEnumerator
                Dim EventCOunter As Integer
                EventCOunter = 1
                EventEnum = CType(anEnum.Current(), Sony.MediaSoftware.Vegas.Track).Events.GetEnumerator
                While EventEnum.MoveNext 'Loop through Events
                    Dim TrackEvent As Sony.MediaSoftware.Vegas.TrackEvent
                    TrackEvent = CType(EventEnum.Current, Sony.MediaSoftware.Vegas.TrackEvent)
                    If TrackEvent.Selected = True Then
                        If (EventCOunter Mod 2) = 0 Then
                            TrackEvent.Mute = True
                        End If
                        EventCOunter = EventCOunter + 1
                    End If
                End While
            End If
        End While
    End Sub

    Private Function GetLength(ByVal TrackEvent As Sony.MediaSoftware.Vegas.TrackEvent) As Long
        Return TrackEvent.Length.FrameCount
    End Function

    Private Function GetStartFrame(ByVal TrackEvent As Sony.MediaSoftware.Vegas.TrackEvent) As Long
        Return TrackEvent.Start.FrameCount
    End Function

End Module
