/**
 * Program: ChangeMediaPoolAspectRatio.js
 * Description: This script will change the aspect ration of all the video media in
 *              the project's media pool to match that of the project.
 * Author: Johnny (Roy) Rofrano john_rofano@hotmail.com
 *
 * Date: March 28, 2004
 **/
import System.Windows.Forms;
import Sony.Vegas;

// Get the aspect ration of the project
var aspectRatio = Vegas.Project.Video.PixelAspectRatio;

var counter = 0;
try 
{
    for (var media in Vegas.Project.MediaPool)
    {
        // only add the effect if the media object has a video stream.
        if (media.HasVideo()) 
        {
            // get the video stream
            var video : VideoStream = media.Streams.GetItemByMediaType(MediaType.Video,0);
            // Set the aspect ratio
            video.PixelAspectRatio = aspectRatio;
            counter++;
        }
    }
    MessageBox.Show(counter + " Video stream(s) changed to " + aspectRatio);
} 
catch (errorMsg)
{
    MessageBox.Show(errorMsg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
}
