/**
 * This script will chop off the front of a clip by the specified number of frames
 * 
 * Written By: Edward Troxel
 * www.jetdv.com/tts
 * Modified: 05-29-2003
 **/

import System;
import System.IO;
import System.Windows.Forms;
import Sony.Vegas;


try {
  var ChopDist : Timecode = new Timecode("00:00:00:06");
  var mtc : Double;

  //Go through the list of Tracks
  var trackEnum = new Enumerator(Vegas.Project.Tracks);
  while (!trackEnum.atEnd()) {
    var track : Track = Track(trackEnum.item());

    //Go through the list of Events
    var eventEnum = new Enumerator(track.Events);
    while (!eventEnum.atEnd()) {
      var evnt : TrackEvent = TrackEvent(eventEnum.item());

      if (evnt.Selected) {

        mtc = ChopDist.ToMilliseconds();
        var dStart : Double = evnt.Start.ToMilliseconds();
        var dLength : Double = evnt.Length.ToMilliseconds();
        var dStart = dStart + mtc;
        var dLength = dLength - mtc;

        evnt.AdjustStartLength(new Timecode(dStart), new Timecode(dLength), false);

      }
      eventEnum.moveNext();
    }
    trackEnum.moveNext();
  }


} catch (e) {
    MessageBox.Show(e);
}

