/**
 * This script will put a marker at the beginning of the selected event with a specified name
 * 
 * Written By: Edward Troxel
 * Copyright 2004 - JETDV Scripts
 * Created: 10-20-2004
 **/

import System.Windows.Forms;
import Sony.Vegas;


try {

  var evnt = FindSelectedEvent();
  if (null == evnt)
      throw "no selected event";

  //Now add and name the marker
  var MyMarker = new Marker(evnt.Start);
  Vegas.Project.Markers.Add(MyMarker);
  MyMarker.Label = "NAME OF MARKER"; //Change this line to change the text of the marker


} catch (e) {
    MessageBox.Show(e);
}



function FindSelectedEvent() : TrackEvent {
  var trackEnum = new Enumerator(Vegas.Project.Tracks);
  while (!trackEnum.atEnd()) {
    var track : Track = Track(trackEnum.item());
    var eventEnum = new Enumerator(track.Events);
    while (!eventEnum.atEnd()) {
      var evnt : TrackEvent = TrackEvent(eventEnum.item());
      if (evnt.Selected) {
          return evnt;
      }
      eventEnum.moveNext();
    }
    trackEnum.moveNext();
  }
  return null;
}

