/** 
* Program: PutInFirstTrackEnd.js
* Description: This script will move selected events(except the one in first track) to 
* the end of the first track. And automatically crossfade with the last event.
* Author: Philip
* 
* Date: August 31, 2003 
**/ 

import Sony.Vegas; 
import System.Windows.Forms;
import Microsoft.Win32;

//time intervals for split events.
var playrate : double = 1;
var fadetime = new Timecode("00:00:01:15");


function DeleteEventInTrack (track)
{
var eventEnum = new Enumerator(track.Events);
var evnt: TrackEvent = TrackEvent(eventEnum.item());
do{
evnt = TrackEvent(eventEnum.item());

if (evnt.Selected) 
{
//Remove events here
track.Events.Remove(evnt);
eventEnum = new Enumerator(track.Events);

}
else 
eventEnum.moveNext();

}while (!eventEnum.atEnd());

}

try
{


// step through all selected video events:
var FirstTrack : Track = Vegas.Project.Tracks.Item(0);

if (FirstTrack.MediaType != MediaType.Video) throw("The first track is not a video track!");

// step through all selected video events:
for (var track in Vegas.Project.Tracks) {
if( track.Index == 0 || track.MediaType != MediaType.Video) continue;

for (var evnt in track.Events) {

if (!evnt.Selected) continue;

if(evnt.Length < new Timecode("06:00") || FirstTrack.Length == new Timecode(0) )
evnt.Copy(FirstTrack,FirstTrack.Length);
else
evnt.Copy(FirstTrack,FirstTrack.Length-fadetime);
} 

DeleteEventInTrack(track); 

}


}

catch (errorMsg)
{
MessageBox.Show(errorMsg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
}
