using System;
using System.Reflection;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Runtime.InteropServices;

public delegate bool EnumWindowsCallBack(int hwnd, int lParam);

namespace VegasRemoteControl
{

[StructLayout(LayoutKind.Sequential)]
public struct COPYDATASTRUCT
{
    public IntPtr dwData;
    public int cbData;
    public IntPtr lpData;
}

public class RC
{
    const int WM_COMMAND = 0x0111;
    const int WM_COPYDATA = 0x004A;

    [DllImport("user32.Dll")]
    public static extern int EnumWindows(EnumWindowsCallBack x, int y); 

    [DllImport("User32.Dll")]
    public static extern void GetWindowText(int h, StringBuilder s, int nMaxCount);

    [DllImport("User32.Dll")]
    public static extern IntPtr SendMessage(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam);

    static void Main(string[] args)
    {
        try
        {
            RC rc = new RC();
            rc.InvokeScript();
        }
        catch (Exception e)
        {
            MessageBox.Show(e.Message);
        }
    }

    static int theVegasHwnd = 0;

    public RC()
    {
        if (!FindVegas())
            throw new Exception("Unable to find a running instance of Vegas");
    }

    public bool FindVegas()
    {
        theVegasHwnd = 0;
        RC.EnumWindows(new EnumWindowsCallBack(RC.EnumWindowsHook), 0);
        if (0 != theVegasHwnd)
            return true;
        return false;
    }

    public void InvokeScript()
    {
        if (0 == theVegasHwnd) return;
        StringBuilder cmdLine = new StringBuilder("vegas40.exe -SCRIPT:");
        cmdLine.Append(GetScriptName());
        IntPtr hCmdLine = Marshal.StringToHGlobalAnsi(cmdLine.ToString());
        COPYDATASTRUCT copyData;
        copyData.dwData = (IntPtr) WM_COMMAND;
        copyData.cbData = cmdLine.Length + 1;
        copyData.lpData = hCmdLine;
        IntPtr hCopyData = Marshal.AllocHGlobal(4*3);
        Marshal.StructureToPtr(copyData, hCopyData, false);
        SendMessage((IntPtr) theVegasHwnd, WM_COPYDATA, (IntPtr) 0, hCopyData);
        Marshal.FreeHGlobal(hCopyData);
        Marshal.FreeHGlobal(hCmdLine);
    }

    private string GetScriptName()
    {
        Assembly thisModule = Assembly.GetExecutingAssembly();
        return Path.Combine(Path.GetDirectoryName(thisModule.Location), "test.js");
    }

    private static bool EnumWindowsHook(int hwnd, int lParam) {
        StringBuilder sb = new StringBuilder(1024);
        GetWindowText(hwnd, sb, sb.Capacity);
        string windowName = sb.ToString();
        if (windowName.EndsWith("Sonic Foundry Vegas 4.0")) {
            theVegasHwnd = hwnd;
            return false;
        }
        return true;
    }

}
}
