// -----Start File

// Written By: David Cornewell
// Email: dcornewell @comcast.net
// Date: July 22, 2003
// Based partially on RenderQueue.js that was
// packaged with Sony.MediaSoftware's Video Vegas 4.0c
//
//

import System;
import System.IO;
import System.Threading 
import System.Windows.Forms;
import System.ComponentModel;
import System.Drawing;
import Sony.Vegas;

//I use the same renderer so I won't put it in an array
var rendererRE = /Windows Media Video V9/;

//Add items to the arrays to specify a dir to check for project files (.veg)
// It will use the appropriate template to render the file
var InputDirs = new Array();
var Templates = new Array();

InputDirs[0] = "E:\\Movies\\To Encode\\movie\\"; Templates[0] = "Movie";
InputDirs[1] = "E:\\Movies\\To Encode\\Cartoon86\\"; Templates[1] = "Cartoon86";
InputDirs[2] = "E:\\Movies\\To Encode\\Cartoon90\\"; Templates[2] = "Cartoon90";
InputDirs[3] = "C:\\"; Templates[3] = "Test";
//InputDirs[3] = "E:\\Movies\\To Encode\\\\"; Templates[3] = ;
var num_encode_dirs=4;


// Set this to a valid out directory or set it to null if you want the
// output files to be created in the same directory as their project
// file.
var defaultOutputDir = null;

// Set the following variable to true if you want to allow the script
// to overrwite existing rendered output files.
var allowFileOverwrites = true;

var iIsRendering: int = 0;

package VegasRenderMachinePkg {
class VegasRenderMachineCls extends System.Windows.Forms.Form {
private var lblPending, lblDone, lblTimer, lblError: Label;
private var listBoxError: ListBox;
private var listViewPending,listViewDone: ListView;
private var btnStart: Button;
private var btnStop: Button;
private var basePanel, bottomPanel, leftPanel, rightPanel: Panel;

function btnStart_Clicked(o : Object, e : EventArgs) {
if (iIsRendering==0) {
var bg : Thread = new Thread(RenderMachine);
bg.Start();
}
}
function btnStop_Clicked(o : Object, e : EventArgs) {
}

function listViewPending_Added(o : Object, e : EventArgs)
{
MessageBox.Show("changed");
return;
}

//
// Define the event handlers for FileSystemWatcher.
//
function OnFileCreated(source: Object, e : FileSystemEventArgs)
{
// MessageBox.Show("File changed: " + e.FullPath + " E.type " + e.ChangeType);
var item1:ListViewItem = new ListViewItem(Path.GetFileNameWithoutExtension(e.FullPath),0);
item1.Checked = false;
item1.SubItems.Add(GetTemplate4Dir(Path.GetDirectoryName(e.FullPath)));
item1.SubItems.Add(e.FullPath);
listViewPending.Items.Add(item1);
if (iIsRendering==0) {
var bg : Thread = new Thread(RenderMachine);
bg.Start();
}
}

function OnFileRenamed(source :Object, e :RenamedEventArgs)
{
// if the To file is a .veg, then use it. if from is, ignore
var ext = Path.GetExtension(e.FullPath);
if (ext == ".veg") {
var item1:ListViewItem = new ListViewItem(Path.GetFileNameWithoutExtension(e.FullPath),0);
item1.Checked = false;
item1.SubItems.Add(GetTemplate4Dir(Path.GetDirectoryName(e.FullPath)));
item1.SubItems.Add(e.FullPath);
listViewPending.Items.Add(item1);
if (iIsRendering==0) {
var bg : Thread = new Thread(RenderMachine);
bg.Start();
}
}
return;
}

function VegasRenderMachineCls() { 
this.Text= "Rending Jobs";
this.ClientSize= new System.Drawing.Size(500,300);
this.StartPosition= System.Windows.Forms.FormStartPosition.CenterScreen;

basePanel= new Panel;
basePanel.Location= new Point(0,0);
basePanel.Size= new System.Drawing.Size(500,300);
basePanel.Name= "basePanel";
basePanel.Anchor= AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Bottom;

leftPanel= new Panel;
leftPanel.Location= new Point(0,0);
leftPanel.Size= new System.Drawing.Size(250,250);
leftPanel.Name= "leftPanel";
leftPanel.Dock= DockStyle.Left;
leftPanel.BorderStyle = "Fixed3D";

lblPending = new Label; 
lblPending.Location= new Point(100,0);
lblPending.Size= new System.Drawing.Size(50,15);
lblPending.Name= "lblPending";
lblPending.Text= "Pending:";
lblPending.Anchor= AnchorStyles.Left | AnchorStyles.Top;
leftPanel.Controls.Add(lblPending); 

listViewPending = new ListView;//Box;
listViewPending.View = View.Details;
listViewPending.GridLines = true;
listViewPending.AllowColumnReorder = true;
listViewPending.Columns.Add("Project Name", -2, HorizontalAlignment.Left);
listViewPending.Columns.Add("Template", -2, HorizontalAlignment.Left);
listViewPending.Columns.Add("Path", -2, HorizontalAlignment.Left);
listViewPending.Location= new Point(3,15);
listViewPending.Size = new System.Drawing.Size(240,155);
listViewPending.Name= "listViewPending";
listViewPending.Anchor= AnchorStyles.Left | AnchorStyles.Top; 
// listViewPending.add_Add(listViewPending_Added); 
leftPanel.Controls.Add(listViewPending);

lblError = new Label; 
lblError.Location= new Point(100,169);
lblError.Size= new System.Drawing.Size(40,15);
lblError.Name= "lblError";
lblError.Text= "Errors:";
lblError.Anchor= AnchorStyles.Left | AnchorStyles.Top;
leftPanel.Controls.Add(lblError); 

listBoxError = new ListBox;
listBoxError.Location= new Point(3,184);
listBoxError.Size = new System.Drawing.Size(240,60);
listBoxError.Name= "listBox1";
// listBoxError.Items.Add();
listBoxError.Anchor= AnchorStyles.Left | AnchorStyles.Top; 
leftPanel.Controls.Add(listBoxError);

rightPanel= new Panel; //ClickPanel
rightPanel.Location= new Point(250,0);
rightPanel.Size= new System.Drawing.Size(250,250);
rightPanel.Name= "rightPanel";
rightPanel.Anchor= AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Bottom;
rightPanel.BorderStyle = "Fixed3D";

lblDone = new Label; 
lblDone.Location= new Point(90,0);
lblDone.Size= new System.Drawing.Size(35,15);
lblDone.Name= "lblDone";
lblDone.Text= "Done:";
lblDone.Anchor= AnchorStyles.Left | AnchorStyles.Top;
rightPanel.Controls.Add(lblDone); 

listViewDone = new ListView;//Box;
listViewDone.View = View.Details;
listViewDone.GridLines = true;
listViewDone.AllowColumnReorder = true;
listViewDone.Columns.Add("Project Name", -2, HorizontalAlignment.Left);
listViewDone.Columns.Add("Template", -2, HorizontalAlignment.Left);
listViewDone.Columns.Add("Path", -2, HorizontalAlignment.Left);
listViewDone.Location= new Point(3,15);
listViewDone.Size = new System.Drawing.Size(240,230);
listViewDone.Name= "listViewPending";
listViewDone.Anchor= AnchorStyles.Left | AnchorStyles.Top; 
rightPanel.Controls.Add(listViewDone);

bottomPanel= new Panel;
bottomPanel.Location= new Point(0,250);
bottomPanel.Size= new System.Drawing.Size(500,50);
bottomPanel.Name= "bottomPanel";
bottomPanel.Anchor= AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Bottom;
bottomPanel.BorderStyle = "Fixed3D";

btnStart= new Button;
btnStart.Location= new Point(190,15);
btnStart.Size= new System.Drawing.Size(50,20);
btnStart.Name= "btnStart";
btnStart.Text= "Start";
btnStart.Anchor= AnchorStyles.Left; 
bottomPanel.Controls.Add(btnStart); 
btnStart.add_Click(btnStart_Clicked); 

btnStop= new Button;
btnStop.Location= new Point(255,15);
btnStop.Size= new System.Drawing.Size(50,20);
btnStop.Name= "btnStop";
btnStop.Text= "Stop";
btnStop.Anchor= AnchorStyles.Left; 
bottomPanel.Controls.Add(btnStop); 
btnStop.add_Click(btnStop_Clicked); 

//
// The filesystem Watcher is to notify me when files are added and need to be put in queue
// I might get delete,rename,etc to update the list. For now, i will NOT delete 
//
var watcher :FileSystemWatcher= new FileSystemWatcher()
watcher.Path = InputDirs[3];
// Type of change to watch for (this code detects when
// new files appear in the directory)
watcher.NotifyFilter = NotifyFilters.FileName;
watcher.IncludeSubdirectories = false;
watcher.Filter = "*.veg";
watcher.add_Created(OnFileCreated);
watcher.add_Renamed(OnFileRenamed);
watcher.EnableRaisingEvents = true;

//
// Put panels on base
//
basePanel.Controls.Add(rightPanel);
basePanel.Controls.Add(bottomPanel);
basePanel.Controls.Add(leftPanel);

RefreshPendingList();
this.Controls.Add(basePanel);

} 

function RefreshPendingList()
{
var fso = new ActiveXObject("Scripting.FileSystemObject");

listViewPending.Clear;
for (var i=0; i<num_encode_dirs; i++) {
if (Directory.Exists(InputDirs[i])) {
var fc = GetFolderFileList(InputDirs[i]);
for (; !fc.atEnd(); fc.moveNext())
{
var ext = fso.GetExtensionName(fc.item());
if (ext == "veg") {
var item1:ListViewItem = new ListViewItem(Path.GetFileNameWithoutExtension(fc.item()),0);
item1.Checked = false;
item1.SubItems.Add(Templates[i]);
item1.SubItems.Add(fc.item());

if (!listViewPending.Items.Contains(item1)) {
listViewPending.Items.Add(item1);
}
}
//MessageBox.Show(fc.item());
}
}
}
return;
}

function RenderMachine()
{
var fc;
var ext;
var fullpath;
var template;

iIsRendering=1; 

if ((null != defaultOutputDir) && !Directory.Exists(defaultOutputDir)) {
SendError("output directory does not exist: " + defaultOutputDir);
return;
}

while (listViewPending.Items.Count > 0) {
var curritem = listViewPending.Items[0];

fullpath = curritem.SubItems[2].Text;
template = curritem.SubItems[1].Text;
if (File.Exists(fullpath)) {
Vegas.NewProject();
var renderStatus = RenderProject(fullpath, rendererRE, template);
if (RenderStatus.Complete == renderStatus) {
var item1:ListViewItem = new ListViewItem(curritem.SubItems[0].Text,0);
item1.Checked = false;
item1.SubItems.Add(curritem.SubItems[1].Text);
item1.SubItems.Add(curritem.SubItems[2].Text);
listViewDone.Items.Add(item1);
listViewPending.Items.Remove(curritem);
var fso = new ActiveXObject("Scripting.FileSystemObject");
fso.MoveFile(fullpath, fullpath+".done");
} else {
SendError("failed to complete render: " + fullpath);
return;
}
}

}
iIsRendering=0;

return;
}

function RenderProject(vegFilename, rendererName, TemplateName)
{
if (!Vegas.OpenProject(vegFilename)) {
SendError("failed to open project file: " + vegFilename);
}

// find the renderer and template
var rendererO : Renderer = FindRenderer(rendererName);
if (null == rendererO) {
SendError("failed to find renderer " + rendererName);
return; 
}

var renderTemplate :RenderTemplate = FindRenderTemplate(rendererO, TemplateName);
if (null == renderTemplate) {
SendError("failed to find render template " + TemplateName);
return; 
}

// get file name extension that will be appended to each output file
var rendererExt = rendererO.FileExtension.substring(1);

// compute the output directory
var outputDir;
if (null == defaultOutputDir) {
outputDir = Path.GetDirectoryName(vegFilename);
} else {
outputDir = defaultOutputDir;
}

// create the output file name
var outputName = Path.GetFileNameWithoutExtension(vegFilename);
var outputFilename = outputDir + Path.DirectorySeparatorChar + outputName + rendererExt;
if ((!allowFileOverwrites) && File.Exists(outputFilename)) {
SendError("file already exists: " + outputFilename);
return; 
}

// perform the render
var renderStatus = Vegas.Render(outputFilename, renderTemplate);
return renderStatus;
}

function GetTemplate4Dir(dir) 
{
for (var i=0; i<num_encode_dirs; i++) {
if (InputDirs[i] == dir) {
return Templates[i];
}
}
return null;
}

// Hopefully this will get me a list of stuff
function GetFolderFileList(folderspec)
{
var fso, f, f1, fc, s;
fso = new ActiveXObject("Scripting.FileSystemObject");
f = fso.GetFolder(folderspec);
fc = new Enumerator(f.files);
return(fc);
}

function FindRenderer(rendererRegExp : RegExp) : Renderer {
var rendererEnum : Enumerator = new Enumerator(Vegas.Renderers);
while (!rendererEnum.atEnd()) {
var renderer : Renderer = Renderer(rendererEnum.item());
if (null != renderer.FileTypeName.match(rendererRegExp)) {
return renderer;
}
rendererEnum.moveNext();
}
return null;
}

// function FindRenderTemplate(renderer : Renderer, templateRegExp : RegExp) : RenderTemplate {
function FindRenderTemplate(renderer : Renderer, templateRegExp ) : RenderTemplate {
var templateEnum : Enumerator = new Enumerator(renderer.Templates);
while (!templateEnum.atEnd()) {
var renderTemplate : RenderTemplate = RenderTemplate(templateEnum.item());
if (renderTemplate.Name ==templateRegExp) {
return renderTemplate;
}
templateEnum.moveNext();
}
return null;
}

function SendError(message)
{
listBoxError.Items.Add(message); // put error into list
return;
}

} 
}

try {
Application.Run(new VegasRenderMachinePkg.VegasRenderMachineCls());
} catch (E) {
throw (E);
}

// -----End File