/** 
 * Program: TrackSetup.js
 * Description: This script will create some initial tracks in Vegas for Video,
 *              Audio, Video Overlay, and Title. This is for people who don't
 *              like the fact that Vegas starts without labeled tracks.
 *
 * Author: Johnny (Roy) Rofrano  john_rofrano@hotmail.com
 * 
 * Date: March 29, 2004
 **/ 

import Sony.Vegas;
import System.Windows.Forms;

try
{
    // Add three video tracks
    AddTrack(1, MediaType.Video, "Title");
    AddTrack(2, MediaType.Video, "Overlay");
    AddTrack(3, MediaType.Video, "Video");

    // Add threee Audio tracks
    AddTrack(4, MediaType.Audio, "Audio");
    AddTrack(5, MediaType.Audio, "Music");
    AddTrack(6, MediaType.Audio, "Effects");
}
catch (errorMsg)
{
	MessageBox.Show(errorMsg, "TrackSetup Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
}

/*
 * Adds a track to the project with a name and index
 */
function AddTrack(index : int, mediaType : MediaType, name : String)
{
	var track;
    if (mediaType == MediaType.Audio)
    { 
        track = new AudioTrack(index, name);    // create audio track
    }
    else
    {
        track = new VideoTrack(index, name);    // create video track
    }

    Vegas.Project.Tracks.Add(track);    // add the track
}
